/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


Main();


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // var oDivGame = document.getElementById("idGameDiv");

    // création du module AngularJS         
    var oModule = angular.module("AppliAngularJS", []);

    // déclaration des contrôleurs
    oModule.controller("MainControler", MainControler) 
      .controller("ViewControler", ViewControler)
      .controller("oList", ListControler)
      .controller("oControler", ControlerSingle);
}


/**
 * Appel suite à une action de l'utilisateur
 * ou un événement
 * 
 * @param {[type]} $scope [description]
 */
function onClicControler($scope) 
{ 
    $scope.nbClic = 0; 
    $scope.nbChangeName = 0;
    $scope.message = "Renseignez vos coordonnées svp.";

    console.log("onClicControler : "+$scope.nbClic);


    /**
     * Sur clic de l'utilisateur sur la liste
     * ng-click
     * 
     * @return {[type]} [description]
     */
    $scope.addOne = function()
    { 
        $scope.nbClic = $scope.nbClic + 1; 
        console.log("addOne : "+$scope.nbClic);
    }


    /**
     * sur renseignement du champ nom par l'utilisateur
     * ng-change
     * 
     * @return {[type]} [description]
     */
    $scope.onChangeInput = function()
    { 
        $scope.nbChangeName = $scope.nbChangeName + 1; 
        console.log("onChangeInput : "+$scope.nbChangeName);
    } 


    /**
     * Appel sur la validation du formulaire par l'utilisateur
     * ng-submit
     * 
     * @return {[type]} [description]
     */
    $scope.onValidForm = function()
    { 
        $scope.message = "Formulaire soumis !";
    }
} 


/**
 * Gestion des éléments de la liste
 * 
 * @param {[type]} $scope [description]
 */
function ListControler($scope)
{ 
    onClicControler($scope);

    // valeurs par défauts
    $scope.quantity = 5; 
    $scope.order = "value"; 
    $scope.query = ""; 

    $scope.items =  [ 
       {name: "PHP", value: 5}, 
       {name: "JavaScript", value: 9}, 
       {name: "CSS", value: 3}, 
       {name: "HTML", value: 5}, 
       {name: "ActionScript", value: 3}, 
       {name: "C", value: 13}, 
       {name: "Assembleur", value: 23} 
    ]; 
  } 

 
/**
 * Le contrôleur
 * 
 * $scope est automatiquement fourni au contrôleur 
 * via le mécanisme d’injection de dépendances utilisé par AngularJS. 
 * 
 * @param {[type]} $scope [description]
 */
function ControlerSingle($scope) 
{ 
    /**
     * init de l'état du modèle
     * ajout du modèle et des fonctions à la vue via l’objet $scope 
     * gestion des changements du modèle
     * 
     */

    // récupère la configuration dans le local storage HTML5 
    /*
    $scope.config = localStorage.getconfig("start") || [];
      
    $scope.addConfig = function(oValue) { ... } 
    $scope.removeConfig = function(oValue) { ... } 
    $scope.doneConfig = function(oValue) { ... } 
    */

  	// représentation du modèle - les données
    $scope.user = { name: "Matthieu", site: "Développement Facile" }; 
    $scope.status = "banniere-cours-prog-facile-950";// affiche une image
}



/**
 * Déclaration des variables des vues
 * 
 * @param {[type]} $scope [description]
 */
function ViewControler($scope) 
{ 
    $scope.pageTitle = "Utilisation d'AngularJS"; 
} 
     

/**
 * Déclaration des variables nécessaires dans la zone gérée par AngularJS
 * 
 * @param {[type]} $scope [description]
 */
function MainControler($scope) 
{ 
    $scope.title = "Application Développement Facile"; 
} 
 
